using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Security.Permissions;
using UnityEngine;
using TMPro;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            CategoryBuilder.Create("Kalashnikov+", "Almost all of kalashnikov guns ", ModAPI.LoadSprite("categorythumb.png"));
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
        NameOverride = "AKM - Kalashnikov+", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The AKM is assualt rifle designed by soviets in 1959 as a replacement of AK-47", //new item description
        CategoryOverride = ModAPI.FindCategory("Kalashnikov+"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("AKM.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AKM.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm"); //load a copy of the 9mm cartridge
            customCartridge.name = "7.6239mm M43"; //set a name
            customCartridge.Damage *= 8.0f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 2.0f; //change the recoil
            customCartridge.ImpactForce *= 1.8f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
            };

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
        NameOverride = "AKS-74U - Kalashnikov+", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The AKS74U is smaller version of AK-74 with short barrell and custom stock designed in 1979 by Soviets", //new item description
        CategoryOverride = ModAPI.FindCategory("Kalashnikov+"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("AKS74U.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AKS74U.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm"); //load a copy of the 9mm cartridge
            customCartridge.name = "5.4539mm M74"; //set a name
            customCartridge.Damage *= 7.0f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 4.2f; //change the recoil
            customCartridge.ImpactForce *= 1.4f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("aks.wav"),
                 ModAPI.LoadSound("aks.wav"),
                 ModAPI.LoadSound("aks.wav"),
            };
            firearm.Automatic = true;
            firearm.AutomaticFireInterval = 0.09f;

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
        }
    }
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
        NameOverride = "AK-74M - Kalashnikov+", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The AK-74M Is Modernized version of the AK-74 designed in 1991 by Russians", //new item description
        CategoryOverride = ModAPI.FindCategory("Kalashnikov+"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("AK74M.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AK74M.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm"); //load a copy of the 9mm cartridge
            customCartridge.name = "5.4539mm M74"; //set a name
            customCartridge.Damage *= 8.0f; //change the damage however you like
            customCartridge.StartSpeed *= 1.7f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.8f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 5.5f; //change the recoil
            customCartridge.ImpactForce *= 2.0f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
{
                ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
};

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
        NameOverride = "AKM + Kobra sight - Kalashnikov+", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "AKM But with a mod that allows to mount a classic red dot kobra sight", //new item description
        CategoryOverride = ModAPI.FindCategory("Kalashnikov+"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("AKMmod.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AKMmod.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm"); //load a copy of the 9mm cartridge
            customCartridge.name = "7.6239mm M43"; //set a name
            customCartridge.Damage *= 8.0f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 3.5f; //change the recoil
            customCartridge.ImpactForce *= 1.8f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
{
                ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
};

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
    NameOverride = "RPK47 - Kalashnikov+", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = "AK-47 with mods that change it to LMG (Light Machine Gun) Shoots faster than others", //new item description
    CategoryOverride = ModAPI.FindCategory("Kalashnikov+"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("RPK47.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //setting the sprite
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("RPK47.png");

        //getting the FirearmBehaviour for later manipulation
        var firearm = Instance.GetComponent<FirearmBehaviour>();

        //creating a custom cartridge for the gun
        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm"); //load a copy of the 9mm cartridge
        customCartridge.name = "7.6239mm M43"; //set a name
        customCartridge.Damage *= 8.0f; //change the damage however you like
        customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
        customCartridge.Recoil *= 2.0f; //change the recoil
        customCartridge.ImpactForce *= 1.8f; //change how much the bullet pushes the target

        //set the cartridge to the FirearmBehaviour
        firearm.Cartridge = customCartridge;

        //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
        firearm.ShotSounds = new AudioClip[]
{
                ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),


    };
        firearm.Automatic = true;
        firearm.AutomaticFireInterval = 0.07f;

        // set the collision box to the new sprite shape
        // this is the easiest way to fix your collision shape, but it also the slowest.
        Instance.FixColliders();
}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
    NameOverride = "AK-12 - Kalashnikov+", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = "The AK-12 is very recognizable russian weapon produced from 2016 by Russians", //new item description
    CategoryOverride = ModAPI.FindCategory("Kalashnikov+"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("AK12.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //settinDg the sprite
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AK12.png");

        //getting the FirearmBehaviour for later manipulation
        var firearm = Instance.GetComponent<FirearmBehaviour>();

        //creating a custom cartridge for the gun
        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm"); //load a copy of the 9mm cartridge
        customCartridge.name = "5.4539mm M74"; //set a name
        customCartridge.Damage *= 8.5f; //change the damage however you like
        customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
        customCartridge.Recoil *= 4.0f; //change the recoil
        customCartridge.ImpactForce *= 1.8f; //change how much the bullet pushes the target

        //set the cartridge to the FirearmBehaviour
        firearm.Cartridge = customCartridge;

        //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
        firearm.ShotSounds = new AudioClip[]
{
                ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
};

        // set the collision box to the new sprite shape
        // this is the easiest way to fix your collision shape, but it also the slowest.
        Instance.FixColliders();
}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
    NameOverride = "AK-BRRRRRRRRRRRRRT - Kalashnikov +", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = "What can i say? BRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRT", //new item description
    CategoryOverride = ModAPI.FindCategory("janpaweldrogixxxddlol"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("AKM.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //settinDg the sprite
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AKM.png");

        //getting the FirearmBehaviour for later manipulation
        var firearm = Instance.GetComponent<FirearmBehaviour>();

        //creating a custom cartridge for the gun
        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm"); //load a copy of the 9mm cartridge
        customCartridge.name = "5.4539mm M74"; //set a name
        customCartridge.Damage *= 999.9f; //change the damage however you like
        customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
        customCartridge.PenetrationRandomAngleMultiplier *= 0.1f; //change the accuracy when the bullet travels through an object
        customCartridge.Recoil *= 1.0f; //change the recoil
        customCartridge.ImpactForce *= 5.0f; //change how much the bullet pushes the target

        //set the cartridge to the FirearmBehaviour
        firearm.Cartridge = customCartridge;

        //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
        firearm.ShotSounds = new AudioClip[]
{
                ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
};
        firearm.Automatic = true;
        firearm.AutomaticFireInterval = 0.01f;

        // set the collision box to the new sprite shape
        // this is the easiest way to fix your collision shape, but it also the slowest.
        Instance.FixColliders();
}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
        NameOverride = "AKS-74 - Kalashnikov+", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The AKS74 is basically AKS74U but with normal barrel :D", //new item description
        CategoryOverride = ModAPI.FindCategory("Kalashnikov+"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("AKS74.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AKS74.png");

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm"); //load a copy of the 9mm cartridge
            customCartridge.name = "5.4539mm M74"; //set a name
            customCartridge.Damage *= 7.0f; //change the damage however you like
            customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 4.2f; //change the recoil
            customCartridge.ImpactForce *= 1.4f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
{
                ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
};
            firearm.Automatic = true;
            firearm.AutomaticFireInterval = 0.09f;

            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
    NameOverride = "AKU-74 - Kalashnikov+", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = "The AK74U is AKS74U but without stock", //new item description
    CategoryOverride = ModAPI.FindCategory("Kalashnikov+"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("AK74U.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //setting the sprite
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AK74U.png");

        //getting the FirearmBehaviour for later manipulation
        var firearm = Instance.GetComponent<FirearmBehaviour>();

        //creating a custom cartridge for the gun
        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm"); //load a copy of the 9mm cartridge
        customCartridge.name = "5.4539mm M74"; //set a name
        customCartridge.Damage *= 7.0f; //change the damage however you like
        customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
        customCartridge.Recoil *= 5.0f; //change the recoil
        customCartridge.ImpactForce *= 1.4f; //change how much the bullet pushes the target

        //set the cartridge to the FirearmBehaviour
        firearm.Cartridge = customCartridge;

        //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
        firearm.ShotSounds = new AudioClip[]
{
                ModAPI.LoadSound("aks.wav"),
                 ModAPI.LoadSound("aks.wav"),
                 ModAPI.LoadSound("aks.wav"),
};
        firearm.Automatic = true;
        firearm.AutomaticFireInterval = 0.09f;

        // set the collision box to the new sprite shape
        // this is the easiest way to fix your collision shape, but it also the slowest.
        Instance.FixColliders();
}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
    NameOverride = "AK-12 + Scope and Flashlight - Kalashnikov+", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = "The AK-12 is very recognizable russian weapon produced from 2016 by Russians", //new item description
    CategoryOverride = ModAPI.FindCategory("Kalashnikov+"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("AK12mod.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //settinDg the sprite
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AK12mod.png");

        //getting the FirearmBehaviour for later manipulation
        var firearm = Instance.GetComponent<FirearmBehaviour>();

        //creating a custom cartridge for the gun
        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm"); //load a copy of the 9mm cartridge
        customCartridge.name = "5.4539mm M74"; //set a name
        customCartridge.Damage *= 8.5f; //change the damage however you like
        customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
        customCartridge.Recoil *= 4.0f; //change the recoil
        customCartridge.ImpactForce *= 1.8f; //change how much the bullet pushes the target

        //set the cartridge to the FirearmBehaviour
        firearm.Cartridge = customCartridge;

        //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
        firearm.ShotSounds = new AudioClip[]
{
                ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
                 ModAPI.LoadSound("chuj.wav"),
};

        // set the collision box to the new sprite shape
        // this is the easiest way to fix your collision shape, but it also the slowest.
        Instance.FixColliders();
}
}
);
            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
    NameOverride = "AKSN-74U", //new item name with a suffix to assure it is globally unique
    DescriptionOverride = "AKS-74U But with nightvision rail + nightvision scope", //new item description
    CategoryOverride = ModAPI.FindCategory("Kalashnikov+"), //new item category
    ThumbnailOverride = ModAPI.LoadSprite("AKSN74U.png"), //new item thumbnail (relative path)
    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
    {
        //settinDg the sprite
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AKSN74U.png");

        //getting the FirearmBehaviour for later manipulation
        var firearm = Instance.GetComponent<FirearmBehaviour>();

        //creating a custom cartridge for the gun
        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm"); //load a copy of the 9mm cartridge
        customCartridge.name = "5.4539mm M74"; //set a name
        customCartridge.Damage *= 7.0f; //change the damage however you like
        customCartridge.StartSpeed *= 1.5f; //change the bullet velocity
        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; //change the accuracy when the bullet travels through an object
        customCartridge.Recoil *= 4.2f; //change the recoil
        customCartridge.ImpactForce *= 1.4f; //change how much the bullet pushes the target

        //set the cartridge to the FirearmBehaviour
        firearm.Cartridge = customCartridge;

        //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
        firearm.ShotSounds = new AudioClip[]
        {
                ModAPI.LoadSound("aks.wav"),
                 ModAPI.LoadSound("aks.wav"),
                 ModAPI.LoadSound("aks.wav"),
        };
        firearm.Automatic = true;
        firearm.AutomaticFireInterval = 0.09f;

        // set the collision box to the new sprite shape
        // this is the easiest way to fix your collision shape, but it also the slowest.
        Instance.FixColliders();
    }
}
);
        }
    }
}

